// Abdeckung für 1HE Rackmount Uhr
// by M. Pöggel '22 - http://www.maltepoeggel.de/ - http://github.com/maltep
// License: CC BY-NC-SA 3.0

$fs=0.25;
$fa=2.5;

$outer_width = 190;
$outer_height = 41;
$outer_depth = 38;
$border_thick = 2;
$screw_dia = 3.5;
$screw_dist_x = 146.7;
$screw_dist_y = 28;
$screw_shift = 30;
$dc_hole_dia = 7;
$dc_hole_shift = 0.675;
$dc_holder_dia = 4;
$dc_holder_screw_dia = 1.8;
$dc_holder_dist = 16;
$dc_holder_length = 7.5;
$dc_holder_shift = 10;
$button_dia = 7.5;
$button_shift_x = 23;
$button_shift_y = 8;
$cable_cutout_width = 10;
$cable_cutout_height = 5;
$side_cutout_height = 5;

union() {
    difference() {
        cube(size = [$outer_width, $outer_height, $outer_depth], center = true);
        union() {
            translate([0, 0, 0.5*$border_thick]) {
                cube(size = [$outer_width-(2*$border_thick), $outer_height-(2*$border_thick), $outer_depth-$border_thick], center = true);
            }
            translate([($screw_shift/2)+($screw_dist_x/2), ($screw_dist_y/2), 0]) {
                cylinder (h = $outer_depth, r=($screw_dia/2), center = true);
            }
            translate([($screw_shift/2)+($screw_dist_x/2), -($screw_dist_y/2), 0]) {
                cylinder (h = $outer_depth, r=($screw_dia/2), center = true);
            }
            translate([($screw_shift/2)-($screw_dist_x/2), ($screw_dist_y/2), 0]) {
                cylinder (h = $outer_depth, r=($screw_dia/2), center = true);
            }
            translate([($screw_shift/2)-($screw_dist_x/2), -($screw_dist_y/2), 0]) {
                cylinder (h = $outer_depth, r=($screw_dia/2), center = true);
            }
            translate([-(($outer_width/2)-$border_thick-$dc_holder_shift), $dc_hole_shift, 0]) {
                cylinder (h = $outer_depth, r=($dc_hole_dia/2), center = true);
            }
            translate([-(($outer_width/2)-$border_thick-$button_shift_x), $button_shift_y, 0]) {
                cylinder (h = $outer_depth, r=($button_dia/2), center = true);
            }
            translate([-(($outer_width-$border_thick)/2), 0, ($outer_depth/2)-($cable_cutout_height/2)]) {
                cube(size = [$border_thick, $cable_cutout_width, $cable_cutout_height], center = true);
            }
            translate([0, (($outer_height-$border_thick)/2), ($outer_depth/2)-($side_cutout_height/2)]) {
                cube(size = [$outer_width, $border_thick, $side_cutout_height], center = true);
            }
            translate([0, -(($outer_height-$border_thick)/2), ($outer_depth/2)-($side_cutout_height/2)]) {
                cube(size = [$outer_width, $border_thick, $side_cutout_height], center = true);
            }
        }
    }
    union() {
        difference() {
            translate([-(($outer_width/2)-$border_thick-$dc_holder_shift), ($dc_holder_dist/2), (($dc_holder_length-$outer_depth)/2)+$border_thick]) {
                cylinder(h = ($dc_holder_length), r=($dc_holder_dia/2), center = true);
            }
            translate([-(($outer_width/2)-$border_thick-$dc_holder_shift), ($dc_holder_dist/2), (($dc_holder_length-$outer_depth)/2)+$border_thick]) {
                cylinder(h = ($dc_holder_length), r=($dc_holder_screw_dia/2), center = true);
            }
        }
        difference() {
            translate([-(($outer_width/2)-$border_thick-$dc_holder_shift), -($dc_holder_dist/2), (($dc_holder_length-$outer_depth)/2)+$border_thick]) {
                cylinder(h = ($dc_holder_length), r=($dc_holder_dia/2), center = true);
            }
            translate([-(($outer_width/2)-$border_thick-$dc_holder_shift), -($dc_holder_dist/2), (($dc_holder_length-$outer_depth)/2+$border_thick)]) {
                cylinder(h = ($dc_holder_length), r=($dc_holder_screw_dia/2), center = true);
            }
        }
    }
}
